Linux 00830bc4dc40 5.4.0-204-generic #224-Ubuntu SMP Thu Dec 5 13:38:28 UTC 2024 x86_64
Apache/2.4
: 172.19.0.2 | : 216.73.217.74
Cant Read [ /etc/named.conf ]
7.4.33
flexusfire
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
README
+ Create Folder
+ Create File
/
usr /
bin /
[ HOME SHELL ]
Name
Size
Permission
Action
X11
[ DIR ]
drwxr-xr-x
2to3-2.7
96
B
-rwxr-xr-x
411toppm
9.87
KB
-rwxr-xr-x
[
58.34
KB
-rwxr-xr-x
aclocal
35.62
KB
-rwxr-xr-x
aclocal-1.16
35.62
KB
-rwxr-xr-x
addpart
30.23
KB
-rwxr-xr-x
addr2line
34.7
KB
-rwxr-xr-x
ambiguous_words
14.23
KB
-rwxr-xr-x
animate
14.15
KB
-rwxr-xr-x
animate-im6
14.15
KB
-rwxr-xr-x
animate-im6.q16
14.15
KB
-rwxr-xr-x
anytopnm
5.55
KB
-rwxr-xr-x
apt
18.38
KB
-rwxr-xr-x
apt-cache
86.46
KB
-rwxr-xr-x
apt-cdrom
30.46
KB
-rwxr-xr-x
apt-config
26.38
KB
-rwxr-xr-x
apt-get
46.46
KB
-rwxr-xr-x
apt-key
27.28
KB
-rwxr-xr-x
apt-mark
62.46
KB
-rwxr-xr-x
ar
66.43
KB
-rwxr-xr-x
arch
38.37
KB
-rwxr-xr-x
argon2
46.01
KB
-rwxr-xr-x
as
680.3
KB
-rwxr-xr-x
asciitopgm
9.87
KB
-rwxr-xr-x
atktopbm
17.87
KB
-rwxr-xr-x
autoconf
14.42
KB
-rwxr-xr-x
autoheader
8.34
KB
-rwxr-xr-x
autom4te
31.91
KB
-rwxr-xr-x
automake
251.9
KB
-rwxr-xr-x
automake-1.16
251.9
KB
-rwxr-xr-x
autoreconf
20.67
KB
-rwxr-xr-x
autoscan
16.73
KB
-rwxr-xr-x
autoupdate
33.08
KB
-rwxr-xr-x
awk
158.74
KB
-rwxr-xr-x
b2sum
58.37
KB
-rwxr-xr-x
base32
42.34
KB
-rwxr-xr-x
base64
42.34
KB
-rwxr-xr-x
basename
38.34
KB
-rwxr-xr-x
bash
1.13
MB
-rwxr-xr-x
bashbug
6.63
KB
-rwxr-xr-x
bioradtopgm
9.87
KB
-rwxr-xr-x
bmptopnm
13.91
KB
-rwxr-xr-x
bmptoppm
13.91
KB
-rwxr-xr-x
brushtopbm
9.87
KB
-rwxr-xr-x
bundle2.7
529
B
-rwxr-xr-x
bundler2.7
531
B
-rwxr-xr-x
bunzip2
38.23
KB
-rwxr-xr-x
bzcat
38.23
KB
-rwxr-xr-x
bzcmp
2.17
KB
-rwxr-xr-x
bzdiff
2.17
KB
-rwxr-xr-x
bzegrep
3.69
KB
-rwxr-xr-x
bzexe
4.76
KB
-rwxr-xr-x
bzfgrep
3.69
KB
-rwxr-xr-x
bzgrep
3.69
KB
-rwxr-xr-x
bzip2
38.23
KB
-rwxr-xr-x
bzip2recover
18.15
KB
-rwxr-xr-x
bzless
1.27
KB
-rwxr-xr-x
bzmore
1.27
KB
-rwxr-xr-x
c++
1.1
MB
-rwxr-xr-x
c++filt
30.27
KB
-rwxr-xr-x
c89
428
B
-rwxr-xr-x
c89-gcc
428
B
-rwxr-xr-x
c99
454
B
-rwxr-xr-x
c99-gcc
454
B
-rwxr-xr-x
c_rehash
6.65
KB
-rwxr-xr-x
captoinfo
90.41
KB
-rwxr-xr-x
cat
42.4
KB
-rwxr-xr-x
catchsegv
3.25
KB
-rwxr-xr-x
cautious-launcher
853
B
-rwxr-xr-x
cc
1.1
MB
-rwxr-xr-x
chage
82.53
KB
-rwxr-sr-x
chardet3
389
B
-rwxr-xr-x
chardetect3
389
B
-rwxr-xr-x
chattr
14.31
KB
-rwxr-xr-x
chcon
70.34
KB
-rwxr-xr-x
chfn
83.07
KB
-rwsr-xr-x
chgrp
70.34
KB
-rwxr-xr-x
chmod
62.37
KB
-rwxr-xr-x
choom
50.23
KB
-rwxr-xr-x
chown
70.34
KB
-rwxr-xr-x
chrt
38.23
KB
-rwxr-xr-x
chsh
51.8
KB
-rwsr-xr-x
cifsdd
90.92
KB
-rwxr-xr-x
cjpeg
46.23
KB
-rwxr-xr-x
cksum
38.34
KB
-rwxr-xr-x
classifier_tester
102.35
KB
-rwxr-xr-x
clear
14.31
KB
-rwxr-xr-x
clear_console
14.23
KB
-rwxr-xr-x
cmp
50.09
KB
-rwxr-xr-x
cmuwmtopbm
9.87
KB
-rwxr-xr-x
cntraining
102.35
KB
-rwxr-xr-x
combine_lang_model
118.31
KB
-rwxr-xr-x
combine_tessdata
18.31
KB
-rwxr-xr-x
comm
42.37
KB
-rwxr-xr-x
compare
14.15
KB
-rwxr-xr-x
compare-im6
14.15
KB
-rwxr-xr-x
compare-im6.q16
14.15
KB
-rwxr-xr-x
compose
18.05
KB
-rwxr-xr-x
composite
14.15
KB
-rwxr-xr-x
composite-im6
14.15
KB
-rwxr-xr-x
composite-im6.q16
14.15
KB
-rwxr-xr-x
conjure
14.15
KB
-rwxr-xr-x
conjure-im6
14.15
KB
-rwxr-xr-x
conjure-im6.q16
14.15
KB
-rwxr-xr-x
convert
14.15
KB
-rwxr-xr-x
convert-im6
14.15
KB
-rwxr-xr-x
convert-im6.q16
14.15
KB
-rwxr-xr-x
corelist
14.73
KB
-rwxr-xr-x
corepack
174
B
-rwxr-xr-x
cp
150.37
KB
-rwxr-xr-x
cpan
7.96
KB
-rwxr-xr-x
cpan5.30-x86_64-linux-gnu
7.98
KB
-rwxr-xr-x
cpp
1.1
MB
-rwxr-xr-x
cpp-9
1.1
MB
-rwxr-xr-x
csplit
54.37
KB
-rwxr-xr-x
curl
234.23
KB
-rwxr-xr-x
cut
46.37
KB
-rwxr-xr-x
cwebp
62.23
KB
-rwxr-xr-x
dash
126.77
KB
-rwxr-xr-x
date
106.37
KB
-rwxr-xr-x
dawg2wordlist
18.31
KB
-rwxr-xr-x
dbus-cleanup-sockets
14.14
KB
-rwxr-xr-x
dbus-daemon
243.2
KB
-rwxr-xr-x
dbus-monitor
30.14
KB
-rwxr-xr-x
dbus-run-session
14.14
KB
-rwxr-xr-x
dbus-send
30.14
KB
-rwxr-xr-x
dbus-update-activation-environ...
14.14
KB
-rwxr-xr-x
dbus-uuidgen
14.14
KB
-rwxr-xr-x
dbwrap_tool
26.52
KB
-rwxr-xr-x
dd
78.38
KB
-rwxr-xr-x
deb-systemd-helper
20.83
KB
-rwxr-xr-x
deb-systemd-invoke
4.33
KB
-rwxr-xr-x
debconf
2.79
KB
-rwxr-xr-x
debconf-apt-progress
11.27
KB
-rwxr-xr-x
debconf-communicate
608
B
-rwxr-xr-x
debconf-copydb
1.68
KB
-rwxr-xr-x
debconf-escape
647
B
-rwxr-xr-x
debconf-set-selections
2.87
KB
-rwxr-xr-x
debconf-show
1.78
KB
-rwxr-xr-x
delpart
30.23
KB
-rwxr-xr-x
df
90.95
KB
-rwxr-xr-x
dh_autotools-dev_restoreconfig
1.79
KB
-rwxr-xr-x
dh_autotools-dev_updateconfig
1.81
KB
-rwxr-xr-x
dh_python2
1.03
KB
-rwxr-xr-x
diff
214.34
KB
-rwxr-xr-x
diff3
66.21
KB
-rwxr-xr-x
dir
138.81
KB
-rwxr-xr-x
dircolors
46.34
KB
-rwxr-xr-x
dirmngr
569.86
KB
-rwxr-xr-x
dirmngr-client
119.06
KB
-rwxr-xr-x
dirname
38.34
KB
-rwxr-xr-x
display
14.15
KB
-rwxr-xr-x
display-im6
14.15
KB
-rwxr-xr-x
display-im6.q16
14.15
KB
-rwxr-xr-x
djpeg
34.23
KB
-rwxr-xr-x
dmesg
82.46
KB
-rwxr-xr-x
dnsdomainname
26.23
KB
-rwxr-xr-x
domainname
26.23
KB
-rwxr-xr-x
dpkg
302.68
KB
-rwxr-xr-x
dpkg-architecture
12.55
KB
-rwxr-xr-x
dpkg-buildflags
7.39
KB
-rwxr-xr-x
dpkg-buildpackage
29.89
KB
-rwxr-xr-x
dpkg-checkbuilddeps
7.45
KB
-rwxr-xr-x
dpkg-deb
174.54
KB
-rwxr-xr-x
dpkg-distaddfile
2.72
KB
-rwxr-xr-x
dpkg-divert
150.59
KB
-rwxr-xr-x
dpkg-genbuildinfo
16.4
KB
-rwxr-xr-x
dpkg-genchanges
17.08
KB
-rwxr-xr-x
dpkg-gencontrol
13.87
KB
-rwxr-xr-x
dpkg-gensymbols
10.65
KB
-rwxr-xr-x
dpkg-maintscript-helper
20.03
KB
-rwxr-xr-x
dpkg-mergechangelogs
8.35
KB
-rwxr-xr-x
dpkg-name
6.63
KB
-rwxr-xr-x
dpkg-parsechangelog
4.46
KB
-rwxr-xr-x
dpkg-query
162.59
KB
-rwxr-xr-x
dpkg-scanpackages
8.49
KB
-rwxr-xr-x
dpkg-scansources
8.95
KB
-rwxr-xr-x
dpkg-shlibdeps
30.68
KB
-rwxr-xr-x
dpkg-source
22.48
KB
-rwxr-xr-x
dpkg-split
122.48
KB
-rwxr-xr-x
dpkg-statoverride
62.27
KB
-rwxr-xr-x
dpkg-trigger
82.49
KB
-rwxr-xr-x
dpkg-vendor
3.19
KB
-rwxr-xr-x
du
106.37
KB
-rwxr-xr-x
dumpelf
58.41
KB
-rwxr-xr-x
dvipdf
1007
B
-rwxr-xr-x
dwebp
34.23
KB
-rwxr-xr-x
dwp
1.95
MB
-rwxr-xr-x
echo
38.34
KB
-rwxr-xr-x
echo_supervisord_conf
419
B
-rwxr-xr-x
edit
18.05
KB
-rwxr-xr-x
egrep
28
B
-rwxr-xr-x
elfedit
42.67
KB
-rwxr-xr-x
enc2xs
41.12
KB
-rwxr-xr-x
encguess
2.99
KB
-rwxr-xr-x
env
42.34
KB
-rwxr-xr-x
eps2eps
639
B
-rwxr-xr-x
erb
4.94
KB
-rwxr-xr-x
erb2.7
4.94
KB
-rwxr-xr-x
exifautotran
1.11
KB
-rwxr-xr-x
expand
42.37
KB
-rwxr-xr-x
expiry
30.58
KB
-rwxr-sr-x
expr
54.34
KB
-rwxr-xr-x
eyuvtoppm
13.87
KB
-rwxr-xr-x
factor
78.37
KB
-rwxr-xr-x
faillog
22.59
KB
-rwxr-xr-x
faked-sysv
34.27
KB
-rwxr-xr-x
faked-tcp
34.25
KB
-rwxr-xr-x
fakeroot
3.76
KB
-rwxr-xr-x
fakeroot-sysv
3.76
KB
-rwxr-xr-x
fakeroot-tcp
3.76
KB
-rwxr-xr-x
fallocate
34.23
KB
-rwxr-xr-x
false
38.34
KB
-rwxr-xr-x
fc-cache
22.23
KB
-rwxr-xr-x
fc-cat
18.23
KB
-rwxr-xr-x
fc-conflist
14.23
KB
-rwxr-xr-x
fc-list
14.23
KB
-rwxr-xr-x
fc-match
14.23
KB
-rwxr-xr-x
fc-pattern
14.23
KB
-rwxr-xr-x
fc-query
14.23
KB
-rwxr-xr-x
fc-scan
14.23
KB
-rwxr-xr-x
fc-validate
14.23
KB
-rwxr-xr-x
ffmpeg
278.3
KB
-rwxr-xr-x
ffplay
142.32
KB
-rwxr-xr-x
ffprobe
170.49
KB
-rwxr-xr-x
fgrep
28
B
-rwxr-xr-x
fiascotopnm
114.45
KB
-rwxr-xr-x
file
26.47
KB
-rwxr-xr-x
fincore
34.27
KB
-rwxr-xr-x
find
312.66
KB
-rwxr-xr-x
findmnt
71.41
KB
-rwxr-xr-x
fitstopnm
13.87
KB
-rwxr-xr-x
flock
34.3
KB
-rwxr-xr-x
fmt
46.34
KB
-rwxr-xr-x
fold
42.34
KB
-rwxr-xr-x
free
26.23
KB
-rwxr-xr-x
fstopgm
9.87
KB
-rwxr-xr-x
funzip
26.15
KB
-rwxr-xr-x
g++
1.1
MB
-rwxr-xr-x
g++-9
1.1
MB
-rwxr-xr-x
g3topbm
12.98
KB
-rwxr-xr-x
gcc
1.1
MB
-rwxr-xr-x
gcc-9
1.1
MB
-rwxr-xr-x
gcc-ar
34.63
KB
-rwxr-xr-x
gcc-ar-9
34.63
KB
-rwxr-xr-x
gcc-nm
34.63
KB
-rwxr-xr-x
gcc-nm-9
34.63
KB
-rwxr-xr-x
gcc-ranlib
34.63
KB
-rwxr-xr-x
gcc-ranlib-9
34.63
KB
-rwxr-xr-x
gcov
656.23
KB
-rwxr-xr-x
gcov-9
656.23
KB
-rwxr-xr-x
gcov-dump
528.13
KB
-rwxr-xr-x
gcov-dump-9
528.13
KB
-rwxr-xr-x
gcov-tool
544.2
KB
-rwxr-xr-x
gcov-tool-9
544.2
KB
-rwxr-xr-x
gdk-pixbuf-csource
14.33
KB
-rwxr-xr-x
gdk-pixbuf-pixdata
14.31
KB
-rwxr-xr-x
gdk-pixbuf-thumbnailer
18.39
KB
-rwxr-xr-x
gem
545
B
-rwxr-xr-x
gem2.7
545
B
-rwxr-xr-x
gemtopbm
9.87
KB
-rwxr-xr-x
gemtopnm
9.87
KB
-rwxr-xr-x
gencat
26.37
KB
-rwxr-xr-x
getconf
34.29
KB
-rwxr-xr-x
getent
38.65
KB
-rwxr-xr-x
getopt
22.23
KB
-rwxr-xr-x
ghostscript
14.15
KB
-rwxr-xr-x
gif2webp
30.23
KB
-rwxr-xr-x
gifdiff
66.38
KB
-rwxr-xr-x
gifsicle
194.66
KB
-rwxr-xr-x
giftopnm
17.87
KB
-rwxr-xr-x
gifview
82.4
KB
-rwxr-xr-x
git
2.98
MB
-rwxr-xr-x
git-receive-pack
2.98
MB
-rwxr-xr-x
git-shell
1.71
MB
-rwxr-xr-x
git-upload-archive
2.98
MB
-rwxr-xr-x
git-upload-pack
2.98
MB
-rwxr-xr-x
gm
14.15
KB
-rwxr-xr-x
gold
2.21
MB
-rwxr-xr-x
gouldtoppm
9.87
KB
-rwxr-xr-x
gpasswd
86.39
KB
-rwsr-xr-x
gpg
1.02
MB
-rwxr-xr-x
gpg-agent
409.04
KB
-rwxr-xr-x
gpg-connect-agent
163.16
KB
-rwxr-xr-x
gpg-wks-server
203.2
KB
-rwxr-xr-x
gpg-zip
3.43
KB
-rwxr-xr-x
gpgcompose
878.29
KB
-rwxr-xr-x
gpgconf
174.66
KB
-rwxr-xr-x
gpgparsemail
34.38
KB
-rwxr-xr-x
gpgsm
507.24
KB
-rwxr-xr-x
gpgsplit
86.76
KB
-rwxr-xr-x
gpgtar
151.63
KB
-rwxr-xr-x
gpgv
447.15
KB
-rwxr-xr-x
gprof
99.88
KB
-rwxr-xr-x
grep
194.47
KB
-rwxr-xr-x
groups
38.34
KB
-rwxr-xr-x
gs
14.15
KB
-rwxr-xr-x
gsbj
350
B
-rwxr-xr-x
gsdj
352
B
-rwxr-xr-x
gsdj500
352
B
-rwxr-xr-x
gslj
353
B
-rwxr-xr-x
gslp
350
B
-rwxr-xr-x
gsnd
277
B
-rwxr-xr-x
gunzip
2.29
KB
-rwxr-xr-x
gzexe
6.3
KB
-rwxr-xr-x
gzip
95.21
KB
-rwxr-xr-x
h2ph
28.54
KB
-rwxr-xr-x
h2xs
59.44
KB
-rwxr-xr-x
head
46.37
KB
-rwxr-xr-x
hipstopgm
9.87
KB
-rwxr-xr-x
hostid
38.34
KB
-rwxr-xr-x
hostname
26.23
KB
-rwxr-xr-x
htmldoc
413.01
KB
-rwxr-xr-x
i386
26.5
KB
-rwxr-xr-x
icontopbm
9.87
KB
-rwxr-xr-x
iconv
66.41
KB
-rwxr-xr-x
id
46.37
KB
-rwxr-xr-x
identify
14.15
KB
-rwxr-xr-x
identify-im6
14.15
KB
-rwxr-xr-x
identify-im6.q16
14.15
KB
-rwxr-xr-x
ifnames
4.03
KB
-rwxr-xr-x
ilbmtoppm
77.95
KB
-rwxr-xr-x
imagetops
1.21
KB
-rwxr-xr-x
img2webp
46.23
KB
-rwxr-xr-x
imgtoppm
9.87
KB
-rwxr-xr-x
import
14.15
KB
-rwxr-xr-x
import-im6
14.15
KB
-rwxr-xr-x
import-im6.q16
14.15
KB
-rwxr-xr-x
infocmp
62.38
KB
-rwxr-xr-x
infotocap
90.41
KB
-rwxr-xr-x
install
154.41
KB
-rwxr-xr-x
instmodsh
4.27
KB
-rwxr-xr-x
ionice
30.23
KB
-rwxr-xr-x
ipcmk
34.3
KB
-rwxr-xr-x
ipcrm
34.23
KB
-rwxr-xr-x
ipcs
66.23
KB
-rwxr-xr-x
irb
507
B
-rwxr-xr-x
irb2.7
507
B
-rwxr-xr-x
ischroot
14.2
KB
-rwxr-xr-x
isql
91.54
KB
-rwxr-xr-x
iusql
65.4
KB
-rwxr-xr-x
java
14.19
KB
-rwxr-xr-x
jexec
14.18
KB
-rwxr-xr-x
jjs
14.23
KB
-rwxr-xr-x
join
54.37
KB
-rwxr-xr-x
jpegexiforient
14.15
KB
-rwxr-xr-x
jpegoptim
38.89
KB
-rwxr-xr-x
jpegtopnm
29.95
KB
-rwxr-xr-x
jpegtran
46.15
KB
-rwxr-xr-x
json_pp
4.56
KB
-rwxr-xr-x
kbxutil
174.97
KB
-rwxr-xr-x
keytool
14.2
KB
-rwxr-xr-x
kill
30.23
KB
-rwxr-xr-x
last
50.23
KB
-rwxr-xr-x
lastb
50.23
KB
-rwxr-xr-x
lastlog
31.66
KB
-rwxr-xr-x
lcf
7.6
KB
-rwxr-xr-x
ld
1.65
MB
-rwxr-xr-x
ld.bfd
1.65
MB
-rwxr-xr-x
ld.gold
2.21
MB
-rwxr-xr-x
ldd
5.3
KB
-rwxr-xr-x
lddtree
6.34
KB
-rwxr-xr-x
leaftoppm
9.87
KB
-rwxr-xr-x
less
175.84
KB
-rwxr-xr-x
lessecho
14.31
KB
-rwxr-xr-x
lessfile
8.36
KB
-rwxr-xr-x
lesskey
23.72
KB
-rwxr-xr-x
lesspipe
8.36
KB
-rwxr-xr-x
libnetcfg
15.41
KB
-rwxr-xr-x
libtoolize
128.25
KB
-rwxr-xr-x
link
38.34
KB
-rwxr-xr-x
linux32
26.5
KB
-rwxr-xr-x
linux64
26.5
KB
-rwxr-xr-x
lispmtopgm
9.87
KB
-rwxr-xr-x
ln
74.38
KB
-rwxr-xr-x
locale
57.56
KB
-rwxr-xr-x
locale-check
14.16
KB
-rwxr-xr-x
localedef
326.96
KB
-rwxr-xr-x
logger
50.82
KB
-rwxr-xr-x
login
55.77
KB
-rwxr-xr-x
logname
38.34
KB
-rwxr-xr-x
ls
138.81
KB
-rwxr-xr-x
lsattr
14.31
KB
-rwxr-xr-x
lsblk
130.23
KB
-rwxr-xr-x
lscpu
98.23
KB
-rwxr-xr-x
lsipc
94.23
KB
-rwxr-xr-x
lslocks
38.55
KB
-rwxr-xr-x
lslogins
66.23
KB
-rwxr-xr-x
lsmem
66.23
KB
-rwxr-xr-x
lsns
50.23
KB
-rwxr-xr-x
lspgpot
1.06
KB
-rwxr-xr-x
lstmeval
118.35
KB
-rwxr-xr-x
lstmtraining
130.35
KB
-rwxr-xr-x
lzcat
78.5
KB
-rwxr-xr-x
lzcmp
6.48
KB
-rwxr-xr-x
lzdiff
6.48
KB
-rwxr-xr-x
lzegrep
5.76
KB
-rwxr-xr-x
lzfgrep
5.76
KB
-rwxr-xr-x
lzgrep
5.76
KB
-rwxr-xr-x
lzless
1.76
KB
-rwxr-xr-x
lzma
78.5
KB
-rwxr-xr-x
lzmainfo
14.23
KB
-rwxr-xr-x
lzmore
2.11
KB
-rwxr-xr-x
m4
158.45
KB
-rwxr-xr-x
macptopbm
9.87
KB
-rwxr-xr-x
make
225.55
KB
-rwxr-xr-x
make-first-existing-target
4.79
KB
-rwxr-xr-x
man
320
B
-rwxr-xr-x
mawk
158.74
KB
-rwxr-xr-x
mcookie
34.3
KB
-rwxr-xr-x
md5sum
46.37
KB
-rwxr-xr-x
md5sum.textutils
46.37
KB
-rwxr-xr-x
mdatopbm
9.87
KB
-rwxr-xr-x
mdsearch
86.3
KB
-rwxr-xr-x
merge_unicharsets
14.23
KB
-rwxr-xr-x
mesa-overlay-control.py
5.67
KB
-rwxr-xr-x
mesg
14.23
KB
-rwxr-xr-x
mftraining
118.35
KB
-rwxr-xr-x
mgrtopbm
9.87
KB
-rwxr-xr-x
migrate-pubring-from-classic-g...
2.99
KB
-rwxr-xr-x
mkdir
86.34
KB
-rwxr-xr-x
mkfifo
66.34
KB
-rwxr-xr-x
mknod
70.34
KB
-rwxr-xr-x
mktemp
46.34
KB
-rwxr-xr-x
mlock
14.15
KB
-rwxr-sr-x
mogrify
14.15
KB
-rwxr-xr-x
mogrify-im6
14.15
KB
-rwxr-xr-x
mogrify-im6.q16
14.15
KB
-rwxr-xr-x
montage
14.15
KB
-rwxr-xr-x
montage-im6
14.15
KB
-rwxr-xr-x
montage-im6.q16
14.15
KB
-rwxr-xr-x
more
42.15
KB
-rwxr-xr-x
mount
54.23
KB
-rwsr-xr-x
mountpoint
14.23
KB
-rwxr-xr-x
mtrace
6.35
KB
-rwxr-xr-x
mtvtoppm
9.87
KB
-rwxr-xr-x
mv
146.38
KB
-rwxr-xr-x
myisam_ftdump
6.58
MB
-rwxr-xr-x
mysql
7.33
MB
-rwxr-xr-x
mysql_config_editor
6.31
MB
-rwxr-xr-x
mysqladmin
7.17
MB
-rwxr-xr-x
mysqlanalyze
7.18
MB
-rwxr-xr-x
mysqlcheck
7.18
MB
-rwxr-xr-x
mysqldump
7.25
MB
-rwxr-xr-x
mysqldumpslow
7.54
KB
-rwxr-xr-x
mysqlimport
7.17
MB
-rwxr-xr-x
mysqloptimize
7.18
MB
-rwxr-xr-x
mysqlpump
7.6
MB
-rwxr-xr-x
mysqlrepair
7.18
MB
-rwxr-xr-x
mysqlreport
38.1
KB
-rwxr-xr-x
mysqlshow
7.17
MB
-rwxr-xr-x
mysqlslap
7.18
MB
-rwxr-xr-x
namei
34.23
KB
-rwxr-xr-x
nawk
158.74
KB
-rwxr-xr-x
nc
42.64
KB
-rwxr-xr-x
nc.openbsd
42.64
KB
-rwxr-xr-x
neotoppm
9.87
KB
-rwxr-xr-x
net
975.24
KB
-rwxr-xr-x
netcat
42.64
KB
-rwxr-xr-x
newgrp
43.73
KB
-rwsr-xr-x
nice
42.34
KB
-rwxr-xr-x
nisdomainname
26.23
KB
-rwxr-xr-x
nl
42.43
KB
-rwxr-xr-x
nm
51.43
KB
-rwxr-xr-x
nmblookup
146.47
KB
-rwxr-xr-x
node
115.88
MB
-rwxr-xr-x
nodejs
115.88
MB
-rwxr-xr-x
nohup
42.34
KB
-rwxr-xr-x
npm
54
B
-rwxr-xr-x
nproc
42.34
KB
-rwxr-xr-x
npx
2.85
KB
-rwxr-xr-x
nsenter
34.43
KB
-rwxr-xr-x
numfmt
66.4
KB
-rwxr-xr-x
objcopy
182.48
KB
-rwxr-xr-x
objdump
392.83
KB
-rwxr-xr-x
od
70.37
KB
-rwxr-xr-x
odbcinst
43.52
KB
-rwxr-xr-x
openssl
735.68
KB
-rwxr-xr-x
optipng
94.11
KB
-rwxr-xr-x
pack200
14.2
KB
-rwxr-xr-x
pager
175.84
KB
-rwxr-xr-x
palmtopnm
17.87
KB
-rwxr-xr-x
pamcut
13.87
KB
-rwxr-xr-x
pamdeinterlace
9.87
KB
-rwxr-xr-x
pamdice
9.87
KB
-rwxr-xr-x
pamfile
9.87
KB
-rwxr-xr-x
pamoil
9.87
KB
-rwxr-xr-x
pamstack
9.87
KB
-rwxr-xr-x
pamstretch
13.87
KB
-rwxr-xr-x
pamstretch-gen
1.31
KB
-rwxr-xr-x
paperconf
13.99
KB
-rwxr-xr-x
partx
118.23
KB
-rwxr-xr-x
passwd
66.61
KB
-rwsr-xr-x
paste
42.37
KB
-rwxr-xr-x
patch
190.52
KB
-rwxr-xr-x
pathchk
38.34
KB
-rwxr-xr-x
pbmclean
9.87
KB
-rwxr-xr-x
pbmlife
9.87
KB
-rwxr-xr-x
pbmmake
9.87
KB
-rwxr-xr-x
pbmmask
9.87
KB
-rwxr-xr-x
pbmpage
9.87
KB
-rwxr-xr-x
pbmpscale
9.98
KB
-rwxr-xr-x
pbmreduce
9.87
KB
-rwxr-xr-x
pbmtext
9.87
KB
-rwxr-xr-x
pbmtextps
13.87
KB
-rwxr-xr-x
pbmto10x
9.87
KB
-rwxr-xr-x
pbmtoascii
10.14
KB
-rwxr-xr-x
pbmtoatk
9.87
KB
-rwxr-xr-x
pbmtobbnbg
9.87
KB
-rwxr-xr-x
pbmtocmuwm
9.87
KB
-rwxr-xr-x
pbmtoepsi
9.87
KB
-rwxr-xr-x
pbmtoepson
9.87
KB
-rwxr-xr-x
pbmtog3
12.98
KB
-rwxr-xr-x
pbmtogem
9.87
KB
-rwxr-xr-x
pbmtogo
9.87
KB
-rwxr-xr-x
pbmtoicon
9.87
KB
-rwxr-xr-x
pbmtolj
13.88
KB
-rwxr-xr-x
pbmtomacp
9.87
KB
-rwxr-xr-x
pbmtomda
9.87
KB
-rwxr-xr-x
pbmtomgr
9.87
KB
-rwxr-xr-x
pbmtonokia
9.87
KB
-rwxr-xr-x
pbmtopgm
9.87
KB
-rwxr-xr-x
pbmtopi3
9.87
KB
-rwxr-xr-x
pbmtoplot
9.87
KB
-rwxr-xr-x
pbmtoppa
33.88
KB
-rwxr-xr-x
pbmtopsg3
11.51
KB
-rwxr-xr-x
pbmtoptx
9.87
KB
-rwxr-xr-x
pbmtowbmp
9.87
KB
-rwxr-xr-x
pbmtox10bm
9.87
KB
-rwxr-xr-x
pbmtoxbm
9.87
KB
-rwxr-xr-x
pbmtoybm
9.87
KB
-rwxr-xr-x
pbmtozinc
9.87
KB
-rwxr-xr-x
pbmupc
17.87
KB
-rwxr-xr-x
pcxtoppm
17.87
KB
-rwxr-xr-x
pdb2
45.02
KB
-rwxr-xr-x
pdb2.7
45.02
KB
-rwxr-xr-x
pdb3
61.27
KB
-rwxr-xr-x
pdb3.8
61.27
KB
-rwxr-xr-x
pdf2dsc
698
B
-rwxr-xr-x
pdf2ps
909
B
-rwxr-xr-x
pdftk
21.92
MB
-rwxr-xr-x
perl
3.32
MB
-rwxr-xr-x
perl5.30-x86_64-linux-gnu
14.3
KB
-rwxr-xr-x
perl5.30.0
3.32
MB
-rwxr-xr-x
perlbug
45.28
KB
-rwxr-xr-x
perldoc
125
B
-rwxr-xr-x
perlivp
10.61
KB
-rwxr-xr-x
perlthanks
45.28
KB
-rwxr-xr-x
pf2afm
498
B
-rwxr-xr-x
pfbtopfa
516
B
-rwxr-xr-x
pgmbentley
5.87
KB
-rwxr-xr-x
pgmcrater
13.9
KB
-rwxr-xr-x
pgmedge
9.87
KB
-rwxr-xr-x
pgmenhance
9.87
KB
-rwxr-xr-x
pgmhist
9.87
KB
-rwxr-xr-x
pgmkernel
9.87
KB
-rwxr-xr-x
pgmnoise
9.87
KB
-rwxr-xr-x
pgmnorm
9.87
KB
-rwxr-xr-x
pgmoil
9.87
KB
-rwxr-xr-x
pgmramp
9.87
KB
-rwxr-xr-x
pgmslice
9.87
KB
-rwxr-xr-x
pgmtexture
25.87
KB
-rwxr-xr-x
pgmtofs
9.87
KB
-rwxr-xr-x
pgmtolispm
9.87
KB
-rwxr-xr-x
pgmtopbm
16.29
KB
-rwxr-xr-x
pgmtoppm
9.87
KB
-rwxr-xr-x
pgrep
30.24
KB
-rwxr-xr-x
pi1toppm
9.87
KB
-rwxr-xr-x
pi3topbm
9.87
KB
-rwxr-xr-x
piconv
8.16
KB
-rwxr-xr-x
pidof
26.38
KB
-rwxr-xr-x
pidproxy
393
B
-rwxr-xr-x
pinentry
66.64
KB
-rwxr-xr-x
pinentry-curses
66.64
KB
-rwxr-xr-x
pinky
42.37
KB
-rwxr-xr-x
pip
365
B
-rwxr-xr-x
pip3
367
B
-rwxr-xr-x
pjtoppm
13.88
KB
-rwxr-xr-x
pkill
30.24
KB
-rwxr-xr-x
pl2pm
4.43
KB
-rwxr-xr-x
pldd
22.37
KB
-rwxr-xr-x
pmap
34.24
KB
-rwxr-xr-x
pngcrush
115.39
KB
-rwxr-xr-x
pngout
88.63
KB
-rwxr-xr-x
pngquant
38.07
KB
-rwxr-xr-x
pngtopnm
21.95
KB
-rwxr-xr-x
pnmalias
13.87
KB
-rwxr-xr-x
pnmarith
9.87
KB
-rwxr-xr-x
pnmcat
9.87
KB
-rwxr-xr-x
pnmcolormap
13.87
KB
-rwxr-xr-x
pnmcomp
9.87
KB
-rwxr-xr-x
pnmconvol
37.87
KB
-rwxr-xr-x
pnmcrop
13.87
KB
-rwxr-xr-x
pnmcut
13.87
KB
-rwxr-xr-x
pnmdepth
9.87
KB
-rwxr-xr-x
pnmenlarge
9.87
KB
-rwxr-xr-x
pnmfile
9.87
KB
-rwxr-xr-x
pnmflip
9.87
KB
-rwxr-xr-x
pnmgamma
13.87
KB
-rwxr-xr-x
pnmhisteq
9.87
KB
-rwxr-xr-x
pnmhistmap
9.88
KB
-rwxr-xr-x
pnmindex
4.49
KB
-rwxr-xr-x
pnminterp
13.87
KB
-rwxr-xr-x
pnminterp-gen
1.31
KB
-rwxr-xr-x
pnminvert
9.87
KB
-rwxr-xr-x
pnmmargin
1.73
KB
-rwxr-xr-x
pnmmontage
13.88
KB
-rwxr-xr-x
pnmnlfilt
21.93
KB
-rwxr-xr-x
pnmnoraw
9.87
KB
-rwxr-xr-x
pnmnorm
9.87
KB
-rwxr-xr-x
pnmpad
9.87
KB
-rwxr-xr-x
pnmpaste
9.87
KB
-rwxr-xr-x
pnmpsnr
9.87
KB
-rwxr-xr-x
pnmquant
3.13
KB
-rwxr-xr-x
pnmremap
17.87
KB
-rwxr-xr-x
pnmrotate
13.87
KB
-rwxr-xr-x
pnmscale
17.87
KB
-rwxr-xr-x
pnmscalefixed
13.87
KB
-rwxr-xr-x
pnmshear
9.87
KB
-rwxr-xr-x
pnmsmooth
9.87
KB
-rwxr-xr-x
pnmsplit
9.87
KB
-rwxr-xr-x
pnmtile
9.87
KB
-rwxr-xr-x
pnmtoddif
13.87
KB
-rwxr-xr-x
pnmtofiasco
199.9
KB
-rwxr-xr-x
pnmtofits
9.87
KB
-rwxr-xr-x
pnmtojpeg
17.87
KB
-rwxr-xr-x
pnmtopalm
17.87
KB
-rwxr-xr-x
pnmtoplainpnm
9.87
KB
-rwxr-xr-x
pnmtopng
29.93
KB
-rwxr-xr-x
pnmtops
17.87
KB
-rwxr-xr-x
pnmtorast
9.87
KB
-rwxr-xr-x
pnmtorle
38.15
KB
-rwxr-xr-x
pnmtosgi
13.87
KB
-rwxr-xr-x
pnmtosir
9.87
KB
-rwxr-xr-x
pnmtotiff
17.87
KB
-rwxr-xr-x
pnmtotiffcmyk
17.87
KB
-rwxr-xr-x
pnmtoxwd
9.87
KB
-rwxr-xr-x
pod2html
4.04
KB
-rwxr-xr-x
pod2man
14.68
KB
-rwxr-xr-x
pod2text
10.55
KB
-rwxr-xr-x
pod2usage
3.86
KB
-rwxr-xr-x
podchecker
3.57
KB
-rwxr-xr-x
podselect
2.47
KB
-rwxr-xr-x
pphs
404
B
-rwxr-xr-x
ppm3d
13.87
KB
-rwxr-xr-x
ppmbrighten
9.87
KB
-rwxr-xr-x
ppmchange
9.87
KB
-rwxr-xr-x
ppmcie
26.04
KB
-rwxr-xr-x
ppmcolormask
9.87
KB
-rwxr-xr-x
ppmcolors
9.87
KB
-rwxr-xr-x
ppmdim
9.87
KB
-rwxr-xr-x
ppmdist
9.87
KB
-rwxr-xr-x
ppmdither
9.87
KB
-rwxr-xr-x
ppmfade
11.39
KB
-rwxr-xr-x
ppmflash
9.87
KB
-rwxr-xr-x
ppmforge
21.88
KB
-rwxr-xr-x
ppmhist
9.87
KB
-rwxr-xr-x
ppmlabel
9.87
KB
-rwxr-xr-x
ppmmake
9.87
KB
-rwxr-xr-x
ppmmix
9.87
KB
-rwxr-xr-x
ppmnorm
9.87
KB
-rwxr-xr-x
ppmntsc
13.88
KB
-rwxr-xr-x
ppmpat
21.87
KB
-rwxr-xr-x
ppmquant
17.87
KB
-rwxr-xr-x
ppmquantall
2.02
KB
-rwxr-xr-x
ppmqvga
13.87
KB
-rwxr-xr-x
ppmrainbow
1.67
KB
-rwxr-xr-x
ppmrelief
9.87
KB
-rwxr-xr-x
ppmshadow
6.67
KB
-rwxr-xr-x
ppmshift
9.87
KB
-rwxr-xr-x
ppmspread
9.87
KB
-rwxr-xr-x
ppmtoacad
14.72
KB
-rwxr-xr-x
ppmtobmp
13.92
KB
-rwxr-xr-x
ppmtoeyuv
9.87
KB
-rwxr-xr-x
ppmtogif
17.88
KB
-rwxr-xr-x
ppmtoicr
9.87
KB
-rwxr-xr-x
ppmtoilbm
37.96
KB
-rwxr-xr-x
ppmtojpeg
17.87
KB
-rwxr-xr-x
ppmtoleaf
9.87
KB
-rwxr-xr-x
ppmtolj
9.87
KB
-rwxr-xr-x
ppmtomap
81
B
-rwxr-xr-x
ppmtomitsu
17.87
KB
-rwxr-xr-x
ppmtompeg
549.78
KB
-rwxr-xr-x
ppmtoneo
9.87
KB
-rwxr-xr-x
ppmtopcx
13.87
KB
-rwxr-xr-x
ppmtopgm
9.87
KB
-rwxr-xr-x
ppmtopi1
9.87
KB
-rwxr-xr-x
ppmtopict
9.87
KB
-rwxr-xr-x
ppmtopj
9.87
KB
-rwxr-xr-x
ppmtopuzz
9.87
KB
-rwxr-xr-x
ppmtorgb3
9.87
KB
-rwxr-xr-x
ppmtosixel
9.87
KB
-rwxr-xr-x
ppmtotga
13.87
KB
-rwxr-xr-x
ppmtouil
9.87
KB
-rwxr-xr-x
ppmtowinicon
17.89
KB
-rwxr-xr-x
ppmtoxpm
13.87
KB
-rwxr-xr-x
ppmtoyuv
9.87
KB
-rwxr-xr-x
ppmtoyuvsplit
9.87
KB
-rwxr-xr-x
ppmtv
9.87
KB
-rwxr-xr-x
pr
74.43
KB
-rwxr-xr-x
print
18.05
KB
-rwxr-xr-x
printafm
395
B
-rwxr-xr-x
printenv
38.34
KB
-rwxr-xr-x
printf
58.34
KB
-rwxr-xr-x
prlimit
38.74
KB
-rwxr-xr-x
prove
13.33
KB
-rwxr-xr-x
ps
134.46
KB
-rwxr-xr-x
ps2ascii
631
B
-rwxr-xr-x
ps2epsi
2.69
KB
-rwxr-xr-x
ps2pdf
272
B
-rwxr-xr-x
ps2pdf12
215
B
-rwxr-xr-x
ps2pdf13
215
B
-rwxr-xr-x
ps2pdf14
215
B
-rwxr-xr-x
ps2pdfwr
1.05
KB
-rwxr-xr-x
ps2ps
647
B
-rwxr-xr-x
ps2ps2
669
B
-rwxr-xr-x
ps2txt
631
B
-rwxr-xr-x
psidtopgm
9.87
KB
-rwxr-xr-x
pspax
50.41
KB
-rwxr-xr-x
pstopnm
17.87
KB
-rwxr-xr-x
ptar
3.47
KB
-rwxr-xr-x
ptardiff
2.57
KB
-rwxr-xr-x
ptargrep
4.29
KB
-rwxr-xr-x
ptx
78.4
KB
-rwxr-xr-x
pwd
42.34
KB
-rwxr-xr-x
pwdx
14.23
KB
-rwxr-xr-x
py3clean
7.63
KB
-rwxr-xr-x
py3compile
11.84
KB
-rwxr-xr-x
py3versions
11.44
KB
-rwxr-xr-x
pyclean
4.03
KB
-rwxr-xr-x
pycompile
11.62
KB
-rwxr-xr-x
pydoc2
79
B
-rwxr-xr-x
pydoc2.7
79
B
-rwxr-xr-x
pydoc3
79
B
-rwxr-xr-x
pydoc3.8
79
B
-rwxr-xr-x
pygettext2
21.56
KB
-rwxr-xr-x
pygettext2.7
21.56
KB
-rwxr-xr-x
pygettext3
21.03
KB
-rwxr-xr-x
pygettext3.8
21.03
KB
-rwxr-xr-x
python
3.49
MB
-rwxr-xr-x
python2
3.49
MB
-rwxr-xr-x
python2.7
3.49
MB
-rwxr-xr-x
python3
5.24
MB
-rwxr-xr-x
python3-config
3.17
KB
-rwxr-xr-x
python3.8
5.24
MB
-rwxr-xr-x
python3.8-config
3.17
KB
-rwxr-xr-x
pyversions
14.76
KB
-rwxr-xr-x
qrttoppm
9.87
KB
-rwxr-xr-x
qt-faststart
18.15
KB
-rwxr-xr-x
racc2.7
586
B
-rwxr-xr-x
racc2y2.7
590
B
-rwxr-xr-x
rake
510
B
-rwxr-xr-x
ranlib
66.46
KB
-rwxr-xr-x
rasttopnm
13.87
KB
-rwxr-xr-x
rawtopgm
9.87
KB
-rwxr-xr-x
rawtoppm
9.87
KB
-rwxr-xr-x
rbash
1.13
MB
-rwxr-xr-x
rcp
114.3
KB
-rwxr-xr-x
rdjpgcom
14.15
KB
-rwxr-xr-x
rdoc
513
B
-rwxr-xr-x
rdoc2.7
513
B
-rwxr-xr-x
readelf
642.93
KB
-rwxr-xr-x
readlink
50.34
KB
-rwxr-xr-x
realpath
50.37
KB
-rwxr-xr-x
rename.ul
22.23
KB
-rwxr-xr-x
renice
14.23
KB
-rwxr-xr-x
reset
30.31
KB
-rwxr-xr-x
resizepart
62.23
KB
-rwxr-xr-x
rev
14.23
KB
-rwxr-xr-x
rgb3toppm
9.87
KB
-rwxr-xr-x
rgrep
30
B
-rwxr-xr-x
ri
509
B
-rwxr-xr-x
ri2.7
509
B
-rwxr-xr-x
rletopnm
34.12
KB
-rwxr-xr-x
rlogin
774.95
KB
-rwxr-xr-x
rm
70.37
KB
-rwxr-xr-x
rmdir
46.34
KB
-rwxr-xr-x
rmid
14.2
KB
-rwxr-xr-x
rmiregistry
14.21
KB
-rwxr-xr-x
rpcclient
1.32
MB
-rwxr-xr-x
rpcgen
98.69
KB
-rwxr-xr-x
rsh
774.95
KB
-rwxr-xr-x
ruby
14.15
KB
-rwxr-xr-x
ruby2.7
14.15
KB
-rwxr-xr-x
run-mailcap
18.05
KB
-rwxr-xr-x
run-parts
26.51
KB
-rwxr-xr-x
runcon
38.34
KB
-rwxr-xr-x
samba-regedit
111.24
KB
-rwxr-xr-x
samba-tool
1.52
KB
-rwxr-xr-x
savelog
10.24
KB
-rwxr-xr-x
sbigtopgm
9.96
KB
-rwxr-xr-x
scanelf
106.41
KB
-rwxr-xr-x
scanmacho
38.41
KB
-rwxr-xr-x
scp
114.3
KB
-rwxr-xr-x
script
54.23
KB
-rwxr-xr-x
scriptreplay
30.23
KB
-rwxr-xr-x
sdiff
50.09
KB
-rwxr-xr-x
sed
118.45
KB
-rwxr-xr-x
see
18.05
KB
-rwxr-xr-x
select-editor
2.38
KB
-rwxr-xr-x
sensible-browser
1.2
KB
-rwxr-xr-x
sensible-editor
1.14
KB
-rwxr-xr-x
sensible-pager
452
B
-rwxr-xr-x
seq
50.34
KB
-rwxr-xr-x
set_unicharset_properties
174.35
KB
-rwxr-xr-x
setarch
26.5
KB
-rwxr-xr-x
setpriv
46.23
KB
-rwxr-xr-x
setsid
14.23
KB
-rwxr-xr-x
setterm
46.23
KB
-rwxr-xr-x
sftp
166.51
KB
-rwxr-xr-x
sg
43.73
KB
-rwsr-xr-x
sgitopnm
13.87
KB
-rwxr-xr-x
sh
126.77
KB
-rwxr-xr-x
sha1sum
50.37
KB
-rwxr-xr-x
sha224sum
58.37
KB
-rwxr-xr-x
sha256sum
58.37
KB
-rwxr-xr-x
sha384sum
66.37
KB
-rwxr-xr-x
sha512sum
66.37
KB
-rwxr-xr-x
shapeclustering
102.35
KB
-rwxr-xr-x
shasum
9.74
KB
-rwxr-xr-x
shred
62.37
KB
-rwxr-xr-x
shuf
58.34
KB
-rwxr-xr-x
sirtopnm
9.87
KB
-rwxr-xr-x
size
34.45
KB
-rwxr-xr-x
skill
30.23
KB
-rwxr-xr-x
slabtop
22.23
KB
-rwxr-xr-x
sldtoppm
17.94
KB
-rwxr-xr-x
sleep
38.34
KB
-rwxr-xr-x
slogin
774.95
KB
-rwxr-xr-x
smbcacls
54.38
KB
-rwxr-xr-x
smbclient
154.48
KB
-rwxr-xr-x
smbcquotas
34.3
KB
-rwxr-xr-x
smbget
30.39
KB
-rwxr-xr-x
smbpasswd
38.3
KB
-rwxr-xr-x
smbspool
26.3
KB
-rwxr-xr-x
smbtar
4.81
KB
-rwxr-xr-x
smbtree
22.3
KB
-rwxr-xr-x
snice
30.23
KB
-rwxr-xr-x
sort
114.63
KB
-rwxr-xr-x
sotruss
4.21
KB
-rwxr-xr-x
spctoppm
9.87
KB
-rwxr-xr-x
splain
18.7
KB
-rwxr-xr-x
split
58.77
KB
-rwxr-xr-x
sprof
34.37
KB
-rwxr-xr-x
sputoppm
9.87
KB
-rwxr-xr-x
ssh
774.95
KB
-rwxr-xr-x
ssh-add
362.28
KB
-rwxr-xr-x
ssh-agent
342.29
KB
-rwxr-sr-x
ssh-argv0
1.42
KB
-rwxr-xr-x
ssh-copy-id
10.41
KB
-rwxr-xr-x
ssh-keygen
466.3
KB
-rwxr-xr-x
ssh-keyscan
454.3
KB
-rwxr-xr-x
st4topgm
9.87
KB
-rwxr-xr-x
stat
86.37
KB
-rwxr-xr-x
stdbuf
50.34
KB
-rwxr-xr-x
stream
14.15
KB
-rwxr-xr-x
stream-im6
14.15
KB
-rwxr-xr-x
stream-im6.q16
14.15
KB
-rwxr-xr-x
strings
34.66
KB
-rwxr-xr-x
strip
182.48
KB
-rwxr-xr-x
stty
82.37
KB
-rwxr-xr-x
su
66.23
KB
-rwsr-xr-x
sum
46.34
KB
-rwxr-xr-x
supervisorctl
403
B
-rwxr-xr-x
supervisord
399
B
-rwxr-xr-x
symcryptrun
123.03
KB
-rwxr-xr-x
symtree
1.98
KB
-rwxr-xr-x
sync
38.34
KB
-rwxr-xr-x
tabs
18.3
KB
-rwxr-xr-x
tac
42.34
KB
-rwxr-xr-x
tail
70.4
KB
-rwxr-xr-x
tar
437.61
KB
-rwxr-xr-x
taskset
34.23
KB
-rwxr-xr-x
tee
42.37
KB
-rwxr-xr-x
tempfile
14.02
KB
-rwxr-xr-x
tesseract
34.23
KB
-rwxr-xr-x
test
54.34
KB
-rwxr-xr-x
testparm
42.3
KB
-rwxr-xr-x
text2image
210.38
KB
-rwxr-xr-x
tgatoppm
13.87
KB
-rwxr-xr-x
thinkjettopbm
17.88
KB
-rwxr-xr-x
tic
90.41
KB
-rwxr-xr-x
tifftopnm
17.87
KB
-rwxr-xr-x
timeout
42.77
KB
-rwxr-xr-x
tload
22.24
KB
-rwxr-xr-x
toe
22.3
KB
-rwxr-xr-x
top
126.05
KB
-rwxr-xr-x
touch
98.37
KB
-rwxr-xr-x
tput
26.34
KB
-rwxr-xr-x
tr
50.34
KB
-rwxr-xr-x
true
38.34
KB
-rwxr-xr-x
truncate
42.34
KB
-rwxr-xr-x
tset
30.31
KB
-rwxr-xr-x
tsort
42.34
KB
-rwxr-xr-x
tty
38.34
KB
-rwxr-xr-x
tzselect
15.02
KB
-rwxr-xr-x
ucf
39.73
KB
-rwxr-xr-x
ucfq
18.91
KB
-rwxr-xr-x
ucfr
10.47
KB
-rwxr-xr-x
umount
38.23
KB
-rwsr-xr-x
uname
38.37
KB
-rwxr-xr-x
uncompress
2.29
KB
-rwxr-xr-x
unexpand
42.37
KB
-rwxr-xr-x
unicharset_extractor
114.31
KB
-rwxr-xr-x
uniq
50.37
KB
-rwxr-xr-x
unlink
38.34
KB
-rwxr-xr-x
unlzma
78.5
KB
-rwxr-xr-x
unpack200
113.02
KB
-rwxr-xr-x
unshare
42.43
KB
-rwxr-xr-x
unxz
78.5
KB
-rwxr-xr-x
unzip
182.29
KB
-rwxr-xr-x
unzipsfx
82.27
KB
-rwxr-xr-x
update-alternatives
54.41
KB
-rwxr-xr-x
update-mime-database
58.37
KB
-rwxr-xr-x
uptime
14.23
KB
-rwxr-xr-x
users
38.34
KB
-rwxr-xr-x
utmpdump
30.23
KB
-rwxr-xr-x
vdir
138.81
KB
-rwxr-xr-x
vmstat
38.25
KB
-rwxr-xr-x
vwebp
30.15
KB
-rwxr-xr-x
w
22.23
KB
-rwxr-xr-x
w.procps
22.23
KB
-rwxr-xr-x
wall
34.23
KB
-rwxr-xr-x
watch
26.57
KB
-rwxr-xr-x
watchgnupg
18.3
KB
-rwxr-xr-x
wbmptopbm
9.87
KB
-rwxr-xr-x
wc
46.34
KB
-rwxr-xr-x
wdctl
34.23
KB
-rwxr-xr-x
webpinfo
30.23
KB
-rwxr-xr-x
webpmux
34.23
KB
-rwxr-xr-x
wget
531.71
KB
-rwxr-xr-x
whereis
34.66
KB
-rwxr-xr-x
which
946
B
-rwxr-xr-x
who
58.37
KB
-rwxr-xr-x
whoami
38.34
KB
-rwxr-xr-x
winicontoppm
17.87
KB
-rwxr-xr-x
wordlist2dawg
22.31
KB
-rwxr-xr-x
wrjpgcom
14.15
KB
-rwxr-xr-x
x86_64
26.5
KB
-rwxr-xr-x
x86_64-linux-gnu-addr2line
34.7
KB
-rwxr-xr-x
x86_64-linux-gnu-ar
66.43
KB
-rwxr-xr-x
x86_64-linux-gnu-as
680.3
KB
-rwxr-xr-x
x86_64-linux-gnu-c++filt
30.27
KB
-rwxr-xr-x
x86_64-linux-gnu-cpp
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-cpp-9
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-dwp
1.95
MB
-rwxr-xr-x
x86_64-linux-gnu-elfedit
42.67
KB
-rwxr-xr-x
x86_64-linux-gnu-g++
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-g++-9
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-9
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar-9
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm-9
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib-9
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov
656.23
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-9
656.23
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump
528.13
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump-9
528.13
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool
544.2
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool-9
544.2
KB
-rwxr-xr-x
x86_64-linux-gnu-gold
2.21
MB
-rwxr-xr-x
x86_64-linux-gnu-gprof
99.88
KB
-rwxr-xr-x
x86_64-linux-gnu-ld
1.65
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.bfd
1.65
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.gold
2.21
MB
-rwxr-xr-x
x86_64-linux-gnu-nm
51.43
KB
-rwxr-xr-x
x86_64-linux-gnu-objcopy
182.48
KB
-rwxr-xr-x
x86_64-linux-gnu-objdump
392.83
KB
-rwxr-xr-x
x86_64-linux-gnu-python3-confi...
3.17
KB
-rwxr-xr-x
x86_64-linux-gnu-python3.8-con...
3.17
KB
-rwxr-xr-x
x86_64-linux-gnu-ranlib
66.46
KB
-rwxr-xr-x
x86_64-linux-gnu-readelf
642.93
KB
-rwxr-xr-x
x86_64-linux-gnu-size
34.45
KB
-rwxr-xr-x
x86_64-linux-gnu-strings
34.66
KB
-rwxr-xr-x
x86_64-linux-gnu-strip
182.48
KB
-rwxr-xr-x
xargs
74.37
KB
-rwxr-xr-x
xauth
54.97
KB
-rwxr-xr-x
xbmtopbm
9.87
KB
-rwxr-xr-x
xdg-user-dir
234
B
-rwxr-xr-x
xdg-user-dirs-update
26.07
KB
-rwxr-xr-x
ximtoppm
13.87
KB
-rwxr-xr-x
xpmtoppm
17.92
KB
-rwxr-xr-x
xsubpp
5.04
KB
-rwxr-xr-x
xvminitoppm
9.87
KB
-rwxr-xr-x
xwdtopnm
17.87
KB
-rwxr-xr-x
xz
78.5
KB
-rwxr-xr-x
xzcat
78.5
KB
-rwxr-xr-x
xzcmp
6.48
KB
-rwxr-xr-x
xzdiff
6.48
KB
-rwxr-xr-x
xzegrep
5.76
KB
-rwxr-xr-x
xzfgrep
5.76
KB
-rwxr-xr-x
xzgrep
5.76
KB
-rwxr-xr-x
xzless
1.76
KB
-rwxr-xr-x
xzmore
2.11
KB
-rwxr-xr-x
y2racc2.7
590
B
-rwxr-xr-x
ybmtopbm
9.87
KB
-rwxr-xr-x
yes
38.34
KB
-rwxr-xr-x
ypdomainname
26.23
KB
-rwxr-xr-x
yuvsplittoppm
9.87
KB
-rwxr-xr-x
yuvtoppm
9.87
KB
-rwxr-xr-x
zcat
1.94
KB
-rwxr-xr-x
zcmp
1.64
KB
-rwxr-xr-x
zdiff
5.76
KB
-rwxr-xr-x
zdump
26.21
KB
-rwxr-xr-x
zegrep
29
B
-rwxr-xr-x
zeisstopnm
9.87
KB
-rwxr-xr-x
zfgrep
29
B
-rwxr-xr-x
zforce
2.03
KB
-rwxr-xr-x
zgrep
7.91
KB
-rwxr-xr-x
zip
211.19
KB
-rwxr-xr-x
zipcloak
91.62
KB
-rwxr-xr-x
zipdetails
49.53
KB
-rwxr-xr-x
zipgrep
2.88
KB
-rwxr-xr-x
zipinfo
182.29
KB
-rwxr-xr-x
zipnote
87.39
KB
-rwxr-xr-x
zipsplit
91.39
KB
-rwxr-xr-x
zless
2.15
KB
-rwxr-xr-x
zmore
1.8
KB
-rwxr-xr-x
znew
4.47
KB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : dpkg-maintscript-helper
#!/bin/sh # # Copyright © 2007, 2011-2015 Guillem Jover <guillem@debian.org> # Copyright © 2010 Raphaël Hertzog <hertzog@debian.org> # Copyright © 2008 Joey Hess <joeyh@debian.org> # Copyright © 2005 Scott James Remnant (original implementation on www.dpkg.org) # # This program is free software; you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation; either version 2 of the License, or # (at your option) any later version. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program. If not, see <https://www.gnu.org/licenses/>. # The conffile related functions are inspired by # https://wiki.debian.org/DpkgConffileHandling # This script is documented in dpkg-maintscript-helper(1) ## ## Functions to remove an obsolete conffile during upgrade ## rm_conffile() { local CONFFILE="$1" local LASTVERSION="$2" local PACKAGE="$3" if [ "$LASTVERSION" = "--" ]; then LASTVERSION="" PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi # Skip remaining parameters up to -- while [ "$1" != "--" -a $# -gt 0 ]; do shift; done [ $# -gt 0 ] || badusage "missing arguments after --" shift [ -n "$PACKAGE" ] || error "couldn't identify the package" [ -n "$1" ] || error "maintainer script parameters are missing" [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \ error "environment variable DPKG_MAINTSCRIPT_NAME is required" [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] || \ error "environment variable DPKG_MAINTSCRIPT_PACKAGE is required" [ "${CONFFILE}" != "${CONFFILE#/}" ] || \ error "conffile '$CONFFILE' is not an absolute path" validate_optional_version "$LASTVERSION" debug "Executing $0 rm_conffile in $DPKG_MAINTSCRIPT_NAME" \ "of $DPKG_MAINTSCRIPT_PACKAGE" debug "CONFFILE=$CONFFILE PACKAGE=$PACKAGE" \ "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2" case "$DPKG_MAINTSCRIPT_NAME" in preinst) if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then prepare_rm_conffile "$CONFFILE" "$PACKAGE" fi ;; postinst) if [ "$1" = "configure" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then finish_rm_conffile "$CONFFILE" fi ;; postrm) if [ "$1" = "purge" ]; then rm -f "$CONFFILE.dpkg-bak" "$CONFFILE.dpkg-remove" \ "$CONFFILE.dpkg-backup" fi if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then abort_rm_conffile "$CONFFILE" "$PACKAGE" fi ;; *) debug "$0 rm_conffile not required in $DPKG_MAINTSCRIPT_NAME" ;; esac } prepare_rm_conffile() { local CONFFILE="$1" local PACKAGE="$2" [ -e "$CONFFILE" ] || return 0 ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0 local md5sum old_md5sum md5sum="$(md5sum "$CONFFILE" | sed -e 's/ .*//')" old_md5sum="$(dpkg-query -W -f='${Conffiles}' "$PACKAGE" | \ sed -n -e "\\'^ $CONFFILE ' { s/ obsolete$//; s/.* //; p }")" if [ "$md5sum" != "$old_md5sum" ]; then mv -f "$CONFFILE" "$CONFFILE.dpkg-backup" else mv -f "$CONFFILE" "$CONFFILE.dpkg-remove" fi } finish_rm_conffile() { local CONFFILE="$1" if [ -e "$CONFFILE.dpkg-backup" ]; then echo "Obsolete conffile $CONFFILE has been modified by you." echo "Saving as $CONFFILE.dpkg-bak ..." mv -f "$CONFFILE.dpkg-backup" "$CONFFILE.dpkg-bak" fi if [ -e "$CONFFILE.dpkg-remove" ]; then echo "Removing obsolete conffile $CONFFILE ..." rm -f "$CONFFILE.dpkg-remove" fi } abort_rm_conffile() { local CONFFILE="$1" local PACKAGE="$2" ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0 if [ -e "$CONFFILE.dpkg-remove" ]; then echo "Reinstalling $CONFFILE that was moved away" mv "$CONFFILE.dpkg-remove" "$CONFFILE" fi if [ -e "$CONFFILE.dpkg-backup" ]; then echo "Reinstalling $CONFFILE that was backed-up" mv "$CONFFILE.dpkg-backup" "$CONFFILE" fi } ## ## Functions to rename a conffile during upgrade ## mv_conffile() { local OLDCONFFILE="$1" local NEWCONFFILE="$2" local LASTVERSION="$3" local PACKAGE="$4" if [ "$LASTVERSION" = "--" ]; then LASTVERSION="" PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi # Skip remaining parameters up to -- while [ "$1" != "--" -a $# -gt 0 ]; do shift; done [ $# -gt 0 ] || badusage "missing arguments after --" shift [ -n "$PACKAGE" ] || error "couldn't identify the package" [ -n "$1" ] || error "maintainer script parameters are missing" [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \ error "environment variable DPKG_MAINTSCRIPT_NAME is required" [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] || \ error "environment variable DPKG_MAINTSCRIPT_PACKAGE is required" [ "${OLDCONFFILE}" != "${OLDCONFFILE#/}" ] || \ error "old-conffile '$OLDCONFFILE' is not an absolute path" [ "${NEWCONFFILE}" != "${NEWCONFFILE#/}" ] || \ error "new-conffile '$NEWCONFFILE' is not an absolute path" validate_optional_version "$LASTVERSION" debug "Executing $0 mv_conffile in $DPKG_MAINTSCRIPT_NAME" \ "of $DPKG_MAINTSCRIPT_PACKAGE" debug "CONFFILE=$OLDCONFFILE -> $NEWCONFFILE PACKAGE=$PACKAGE" \ "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2" case "$DPKG_MAINTSCRIPT_NAME" in preinst) if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then prepare_mv_conffile "$OLDCONFFILE" "$PACKAGE" fi ;; postinst) if [ "$1" = "configure" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then finish_mv_conffile "$OLDCONFFILE" "$NEWCONFFILE" "$PACKAGE" fi ;; postrm) if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then abort_mv_conffile "$OLDCONFFILE" "$PACKAGE" fi ;; *) debug "$0 mv_conffile not required in $DPKG_MAINTSCRIPT_NAME" ;; esac } prepare_mv_conffile() { local CONFFILE="$1" local PACKAGE="$2" [ -e "$CONFFILE" ] || return 0 ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0 local md5sum old_md5sum md5sum="$(md5sum "$CONFFILE" | sed -e 's/ .*//')" old_md5sum="$(dpkg-query -W -f='${Conffiles}' "$PACKAGE" | \ sed -n -e "\\'^ $CONFFILE ' { s/ obsolete$//; s/.* //; p }")" if [ "$md5sum" = "$old_md5sum" ]; then mv -f "$CONFFILE" "$CONFFILE.dpkg-remove" fi } finish_mv_conffile() { local OLDCONFFILE="$1" local NEWCONFFILE="$2" local PACKAGE="$3" rm -f "$OLDCONFFILE.dpkg-remove" [ -e "$OLDCONFFILE" ] || return 0 ensure_package_owns_file "$PACKAGE" "$OLDCONFFILE" || return 0 echo "Preserving user changes to $NEWCONFFILE (renamed from $OLDCONFFILE)..." if [ -e "$NEWCONFFILE" ]; then mv -f "$NEWCONFFILE" "$NEWCONFFILE.dpkg-new" fi mv -f "$OLDCONFFILE" "$NEWCONFFILE" } abort_mv_conffile() { local CONFFILE="$1" local PACKAGE="$2" ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0 if [ -e "$CONFFILE.dpkg-remove" ]; then echo "Reinstalling $CONFFILE that was moved away" mv "$CONFFILE.dpkg-remove" "$CONFFILE" fi } ## ## Functions to replace a symlink with a directory ## symlink_to_dir() { local SYMLINK="$1" local SYMLINK_TARGET="$2" local LASTVERSION="$3" local PACKAGE="$4" if [ "$LASTVERSION" = "--" ]; then LASTVERSION="" PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi # Skip remaining parameters up to -- while [ "$1" != "--" -a $# -gt 0 ]; do shift; done [ $# -gt 0 ] || badusage "missing arguments after --" shift [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \ error "environment variable DPKG_MAINTSCRIPT_NAME is required" [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] || \ error "environment variable DPKG_MAINTSCRIPT_PACKAGE is required" [ -n "$PACKAGE" ] || error "cannot identify the package" [ -n "$SYMLINK" ] || error "symlink parameter is missing" [ "${SYMLINK#/}" = "$SYMLINK" ] && \ error "symlink pathname is not an absolute path" [ "${SYMLINK%/}" = "$SYMLINK" ] || \ error "symlink pathname ends with a slash" [ -n "$SYMLINK_TARGET" ] || error "original symlink target is missing" [ -n "$1" ] || error "maintainer script parameters are missing" validate_optional_version "$LASTVERSION" debug "Executing $0 symlink_to_dir in $DPKG_MAINTSCRIPT_NAME" \ "of $DPKG_MAINTSCRIPT_PACKAGE" debug "SYMLINK=$SYMLINK -> $SYMLINK_TARGET PACKAGE=$PACKAGE" \ "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2" case "$DPKG_MAINTSCRIPT_NAME" in preinst) if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] && [ -h "$SYMLINK" ] && symlink_match "$SYMLINK" "$SYMLINK_TARGET" && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then mv -f "$SYMLINK" "${SYMLINK}.dpkg-backup" fi ;; postinst) # We cannot bail depending on the version, as here we only # know what was the last configured version, and we might # have been unpacked, then upgraded with an unpack and thus # never been configured before. if [ "$1" = "configure" ] && [ -h "${SYMLINK}.dpkg-backup" ] && symlink_match "${SYMLINK}.dpkg-backup" "$SYMLINK_TARGET" then rm -f "${SYMLINK}.dpkg-backup" fi ;; postrm) if [ "$1" = "purge" ] && [ -h "${SYMLINK}.dpkg-backup" ]; then rm -f "${SYMLINK}.dpkg-backup" fi if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] && [ -n "$2" ] && [ ! -e "$SYMLINK" ] && [ -h "${SYMLINK}.dpkg-backup" ] && symlink_match "${SYMLINK}.dpkg-backup" "$SYMLINK_TARGET" && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then echo "Restoring backup of $SYMLINK ..." mv "${SYMLINK}.dpkg-backup" "$SYMLINK" fi ;; *) debug "$0 symlink_to_dir not required in $DPKG_MAINTSCRIPT_NAME" ;; esac } ## ## Functions to replace a directory with a symlink ## dir_to_symlink() { local PATHNAME="${1%/}" local SYMLINK_TARGET="$2" local LASTVERSION="$3" local PACKAGE="$4" if [ "$LASTVERSION" = "--" ]; then LASTVERSION="" PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi # Skip remaining parameters up to -- while [ "$1" != "--" -a $# -gt 0 ]; do shift; done [ $# -gt 0 ] || badusage "missing arguments after --" shift [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \ error "environment variable DPKG_MAINTSCRIPT_NAME is required" [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] || \ error "environment variable DPKG_MAINTSCRIPT_PACKAGE is required" [ -n "$PACKAGE" ] || error "cannot identify the package" [ -n "$PATHNAME" ] || error "directory parameter is missing" [ "${PATHNAME#/}" = "$PATHNAME" ] && \ error "directory parameter is not an absolute path" [ -n "$SYMLINK_TARGET" ] || error "new symlink target is missing" [ -n "$1" ] || error "maintainer script parameters are missing" validate_optional_version "$LASTVERSION" debug "Executing $0 dir_to_symlink in $DPKG_MAINTSCRIPT_NAME" \ "of $DPKG_MAINTSCRIPT_PACKAGE" debug "PATHNAME=$PATHNAME SYMLINK_TARGET=$SYMLINK_TARGET" \ "PACKAGE=$PACKAGE LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2" case "$DPKG_MAINTSCRIPT_NAME" in preinst) if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] && [ ! -h "$PATHNAME" ] && [ -d "$PATHNAME" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then prepare_dir_to_symlink "$PACKAGE" "$PATHNAME" fi ;; postinst) # We cannot bail depending on the version, as here we only # know what was the last configured version, and we might # have been unpacked, then upgraded with an unpack and thus # never been configured before. if [ "$1" = "configure" ] && [ -d "${PATHNAME}.dpkg-backup" ] && [ ! -h "$PATHNAME" ] && [ -d "$PATHNAME" ] && [ -f "$PATHNAME/.dpkg-staging-dir" ]; then finish_dir_to_symlink "$PATHNAME" "$SYMLINK_TARGET" fi ;; postrm) if [ "$1" = "purge" ] && [ -d "${PATHNAME}.dpkg-backup" ]; then rm -rf "${PATHNAME}.dpkg-backup" fi if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] && [ -n "$2" ] && [ -d "${PATHNAME}.dpkg-backup" ] && [ \( ! -h "$PATHNAME" -a -d "$PATHNAME" -a \ -f "$PATHNAME/.dpkg-staging-dir" \) -o \ \( -h "$PATHNAME" -a \ \( "$(readlink "$PATHNAME")" = "$SYMLINK_TARGET" -o \ "$(readlink -f "$PATHNAME")" = "$SYMLINK_TARGET" \) \) ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then abort_dir_to_symlink "$PATHNAME" fi ;; *) debug "$0 dir_to_symlink not required in $DPKG_MAINTSCRIPT_NAME" ;; esac } prepare_dir_to_symlink() { local PACKAGE="$1" local PATHNAME="$2" local LINE # If there are conffiles we should not perform the switch. dpkg-query -W -f='${Conffiles}\n' "$PACKAGE" | while read -r LINE; do case "$LINE" in "$PATHNAME"/*) error "directory '$PATHNAME' contains conffiles," \ "cannot switch to symlink" ;; esac done # If there are locally created files or files owned by another package # we should not perform the switch. export DPKG_MAINTSCRIPT_HELPER_INTERNAL_API="$version" find "$PATHNAME" -print0 | \ xargs -0 -n1 "$0" _internal_pkg_must_own_file "$PACKAGE" || \ error "directory '$PATHNAME' contains files not owned by" \ "package $PACKAGE, cannot switch to symlink" unset DPKG_MAINTSCRIPT_HELPER_INTERNAL_API # At this point, we know that the directory either contains no files, # or only non-conffiles owned by the package. # # To do the switch we cannot simply replace it with the final symlink # just yet, because dpkg needs to remove any file present in the old # package that have disappeared in the new one, and we do not want to # lose files resolving to the same pathname in the symlink target. # # We cannot replace the directory with a staging symlink either, # because dpkg will update symlinks to their new target. # # So we need to create a staging directory, to avoid removing files # from other packages, and to trap any new files in the directory # to move them to their correct place later on. mv -f "$PATHNAME" "${PATHNAME}.dpkg-backup" mkdir "$PATHNAME" # Mark it as a staging directory, so that we can track things. touch "$PATHNAME/.dpkg-staging-dir" } finish_dir_to_symlink() { local PATHNAME="$1" local SYMLINK_TARGET="$2" # Move the contents of the staging directory to the symlink target, # as those are all new files installed between this package being # unpacked and configured. local ABS_SYMLINK_TARGET if [ "${SYMLINK_TARGET#/}" = "$SYMLINK_TARGET" ]; then ABS_SYMLINK_TARGET="$(dirname "$PATHNAME")/$SYMLINK_TARGET" else ABS_SYMLINK_TARGET="$SYMLINK_TARGET" fi rm "$PATHNAME/.dpkg-staging-dir" find "$PATHNAME" -mindepth 1 -maxdepth 1 -print0 | \ xargs -0 -i% mv -f "%" "$ABS_SYMLINK_TARGET/" # Remove the staging directory. rmdir "$PATHNAME" # Do the actual switch. ln -s "$SYMLINK_TARGET" "$PATHNAME" # We are left behind the old files owned by this package in the backup # directory, just remove it. rm -rf "${PATHNAME}.dpkg-backup" } abort_dir_to_symlink() { local PATHNAME="$1" echo "Restoring backup of $PATHNAME ..." if [ -h "$PATHNAME" ]; then rm -f "$PATHNAME" else # The staging directory must be empty, as no other package # should have been unpacked in between. rm -f "$PATHNAME/.dpkg-staging-dir" rmdir "$PATHNAME" fi mv "${PATHNAME}.dpkg-backup" "$PATHNAME" } # Common functions validate_optional_version() { local VERSION="$1" if [ -z "$VERSION" ]; then return fi if ! VERSIONCHECK=$(dpkg --validate-version -- "$VERSION" 2>&1); then error "$VERSIONCHECK" fi } ensure_package_owns_file() { local PACKAGE="$1" local FILE="$2" if ! dpkg-query -L "$PACKAGE" | grep -F -q -x "$FILE"; then debug "File '$FILE' not owned by package " \ "'$PACKAGE', skipping $command" return 1 fi return 0 } internal_pkg_must_own_file() { local PACKAGE="$1" local FILE="$2" if [ "$DPKG_MAINTSCRIPT_HELPER_INTERNAL_API" != "$version" ]; then error "internal API used by external command" fi if ! ensure_package_owns_file "$PACKAGE" "$FILE"; then error "file '$FILE' not owned by package '$PACKAGE'" fi return 0 } symlink_match() { local SYMLINK="$1" local SYMLINK_TARGET="$2" [ "$(readlink "$SYMLINK")" = "$SYMLINK_TARGET" ] || \ [ "$(readlink -f "$SYMLINK")" = "$SYMLINK_TARGET" ] } # Standard ANSI colors and attributes. COLOR_NORMAL='' COLOR_RESET='[0m' COLOR_BOLD='[1m' COLOR_BLACK='[30m' COLOR_RED='[31m' COLOR_GREEN='[32m' COLOR_YELLOW='[33m' COLOR_BLUE='[34m' COLOR_MAGENTA='[35m' COLOR_CYAN='[36m' COLOR_WHITE='[37m' COLOR_BOLD_BLACK='[1;30m' COLOR_BOLD_RED='[1;31m' COLOR_BOLD_GREEN='[1;32m' COLOR_BOLD_YELLOW='[1;33m' COLOR_BOLD_BLUE='[1;34m' COLOR_BOLD_MAGENTA='[1;35m' COLOR_BOLD_CYAN='[1;36m' COLOR_BOLD_WHITE='[1;37m' setup_colors() { : "${DPKG_COLORS=auto}" case "$DPKG_COLORS" in auto) if [ -t 1 ]; then USE_COLORS=yes else USE_COLORS=no fi ;; always) USE_COLORS=yes ;; *) USE_COLORS=no ;; esac if [ $USE_COLORS = yes ]; then COLOR_PROG="$COLOR_BOLD" COLOR_INFO="$COLOR_GREEN" COLOR_NOTICE="$COLOR_YELLOW" COLOR_WARN="$COLOR_BOLD_YELLOW" COLOR_ERROR="$COLOR_BOLD_RED" else COLOR_RESET="" fi FMT_PROG="$COLOR_PROG$PROGNAME$COLOR_RESET" } debug() { if [ -n "$DPKG_DEBUG" ]; then echo "DEBUG: $FMT_PROG: $*" >&2 fi } error() { echo "$FMT_PROG: ${COLOR_ERROR}error${COLOR_RESET}: $*" >&2 exit 1 } warning() { echo "$FMT_PROG: ${COLOR_WARN}warning${COLOR_RESET}: $*" >&2 } usage() { cat <<END Usage: $PROGNAME <command> <parameter>... -- <maintainer-script-parameter>... Commands: supports <command> Returns 0 (success) if the given command is supported, 1 otherwise. rm_conffile <conffile> [<last-version> [<package>]] Remove obsolete conffile. Must be called in preinst, postinst and postrm. mv_conffile <old-conf> <new-conf> [<last-version> [<package>]] Rename a conffile. Must be called in preinst, postinst and postrm. symlink_to_dir <pathname> <old-symlink-target> [<last-version> [<package>]] Replace a symlink with a directory. Must be called in preinst, postinst and postrm. dir_to_symlink <pathname> <new-symlink-target> [<last-version> [<package>]] Replace a directory with a symlink. Must be called in preinst, postinst and postrm. help Display this usage information. END } badusage() { echo "$FMT_PROG: ${COLOR_ERROR}error${COLOR_RESET}: $1" >&2 echo >&2 echo "Use '$PROGNAME help' for program usage information." >&2 exit 1 } # Main code set -e PROGNAME=$(basename "$0") version="1.19.7" setup_colors command="$1" [ $# -gt 0 ] || badusage "missing command" shift case "$command" in supports) case "$1" in rm_conffile|mv_conffile|symlink_to_dir|dir_to_symlink) code=0 ;; *) code=1 ;; esac if [ -z "$DPKG_MAINTSCRIPT_NAME" ]; then warning "environment variable DPKG_MAINTSCRIPT_NAME missing" code=1 fi if [ -z "$DPKG_MAINTSCRIPT_PACKAGE" ]; then warning "environment variable DPKG_MAINTSCRIPT_PACKAGE missing" code=1 fi exit $code ;; rm_conffile) rm_conffile "$@" ;; mv_conffile) mv_conffile "$@" ;; symlink_to_dir) symlink_to_dir "$@" ;; dir_to_symlink) dir_to_symlink "$@" ;; _internal_pkg_must_own_file) # This is an internal command, must not be used outside this program. internal_pkg_must_own_file "$@" ;; --help|help|-?) usage ;; --version) cat <<-END Debian $PROGNAME version $version. This is free software; see the GNU General Public License version 2 or later for copying conditions. There is NO warranty. END ;; *) badusage "command $command is unknown Hint: upgrading dpkg to a newer version might help." esac exit 0
Close